EAPI EAPI_WEAK EFL_FUNC_BODY_CONST(efl_screen_size_in_pixels_get, Eina_Size2D, ((Eina_Size2D){0}));

static Eina_Value
__eolian_efl_screen_screen_scale_factor_get_reflect(const Eo *obj)
{
   float val = efl_screen_scale_factor_get(obj);
   return eina_value_float_init(val);
}

EAPI EAPI_WEAK EFL_FUNC_BODY_CONST(efl_screen_scale_factor_get, float, 0);

static Eina_Value
__eolian_efl_screen_screen_rotation_get_reflect(const Eo *obj)
{
   int val = efl_screen_rotation_get(obj);
   return eina_value_int_init(val);
}

EAPI EAPI_WEAK EFL_FUNC_BODY_CONST(efl_screen_rotation_get, int, 0);
EAPI EAPI_WEAK EFL_VOID_FUNC_BODYV_CONST(efl_screen_dpi_get, EFL_FUNC_CALL(xdpi, ydpi), int *xdpi, int *ydpi);

static Eina_Bool
_efl_screen_class_initializer(Efl_Class *klass)
{
   const Efl_Object_Ops *opsp = NULL;

   const Efl_Object_Property_Reflection_Ops *ropsp = NULL;

#ifndef EFL_SCREEN_EXTRA_OPS
#define EFL_SCREEN_EXTRA_OPS
#endif

   EFL_OPS_DEFINE(ops,
      EFL_OBJECT_OP_FUNC(efl_screen_size_in_pixels_get, NULL),
      EFL_OBJECT_OP_FUNC(efl_screen_scale_factor_get, NULL),
      EFL_OBJECT_OP_FUNC(efl_screen_rotation_get, NULL),
      EFL_OBJECT_OP_FUNC(efl_screen_dpi_get, NULL),
      EFL_SCREEN_EXTRA_OPS
   );
   opsp = &ops;

   static const Efl_Object_Property_Reflection refl_table[] = {
      {"screen_scale_factor", NULL, __eolian_efl_screen_screen_scale_factor_get_reflect},
      {"screen_rotation", NULL, __eolian_efl_screen_screen_rotation_get_reflect},
   };
   static const Efl_Object_Property_Reflection_Ops rops = {
      refl_table, EINA_C_ARRAY_LENGTH(refl_table)
   };
   ropsp = &rops;

   return efl_class_functions_set(klass, opsp, ropsp);
}

static const Efl_Class_Description _efl_screen_class_desc = {
   EO_VERSION,
   "Efl.Screen",
   EFL_CLASS_TYPE_INTERFACE,
   0,
   _efl_screen_class_initializer,
   NULL,
   NULL
};

EFL_DEFINE_CLASS(efl_screen_interface_get, &_efl_screen_class_desc, NULL, NULL);
